#include <stdio.h>
#include <unistd.h>
#include "fonctions.h"

/* lit un int depuis fd */
int read_int(int fd) {
  int res;
  int nbRead = read(fd, &res, sizeof(int));
  if (nbRead < sizeof(int)) {
	perror("pb lecture sur pipe nomme");
  }
  //printf("Recu: un int : %d\n", res);
  return res;
}

/* ecrit un int sur fd */
void write_int(int fd, int value) {
  int nbWrite = write(fd, &value, sizeof(value));
  if (nbWrite < sizeof(value)) {
	perror("pb ecriture sur pipe nomme");
  }
}


/* lit un double depuis fd */
double read_double(int fd) {

  double res;
  int nbRead = read(fd, &res, sizeof(double));
  if (nbRead < sizeof(double)) {
	perror("pb lecture sur pipe nomme");
  }
  //printf("Recu: un double : %lf\n", res);
  return res;
}

/* ecrit un double sur fd */
void write_double(int fd, double value) {
  int nbWrite = write(fd, &value, sizeof(double));
  if (nbWrite < sizeof(double)) {
    perror("pb ecriture sur pipe nomme");
  }
}


/* lit une chaine de caracteres depuis fd */
void read_str(int fd, char* str, int*len) {
  int l = read_int(fd);
  *len = l;

  int nbRead = read(fd, str, sizeof(char)* (*len));
  if (nbRead < sizeof(char)* (*len)) {
	perror("pb lecture sur pipe nomme");
  }
}

/* ecrit une chaine de caracteres sur fd */
void write_str(int fd, char* str, int len) {
  write_int(fd, len);
  int nbWrite = write(fd, str, sizeof(char)*len);
  if (nbWrite < sizeof(char)*len) {
	perror("pb ecriture sur pipe nomme");
  }
}



/* lit un vecteur de taille size depuis fd */
void read_vecteur_allocated(int fd, struct vecteur* v) {
  int i;
  for(i=0; i<v->size; i++) {
    v->values[i] = read_double(fd);
  }
}

/* lit un vecteur de taille size depuis fd */
struct vecteur* read_vecteur(int fd) {
  int size = read_int(fd);

  struct vecteur* res = NULL;
  res = new_vecteur(size);
  read_vecteur_allocated(fd, res);
  return res;
}

/* ecrit un vecteur sur fd */
void write_vecteur_allocated(int fd, struct vecteur* v) {
  int i;
  for(i=0; i<v->size; i++) {
    write_double(fd, v->values[i]);
  }
}


/* ecrit un vecteur sur fd */
void write_vecteur(int fd, struct vecteur* v) {
  write_int(fd, v->size);
  write_vecteur_allocated(fd, v);
}



