#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "fonctions.h"

/* calcule a + b */
double somme(double a, double b) {
  printf("Calcul de somme(%lf, %lf)\n", a, b);
  return a + b;
}

double mul(double a, double b) {
  printf("Calcul de mul(%lf, %lf)\n", a, b);
  return a*b;
}

/* affiche un double */
void print(double a) {
  printf("%lf\n", a);
}




/* res = a + b.
 * a, b et res sont des tableaux de n doubles
 */
void sommev(struct vecteur *a, struct vecteur *b, struct vecteur *res) {

  assert(a->size == b->size);
  assert(a->size == res->size);

  printf("Calcul de sommv(taille des vecteurs: %d)\n", a->size);

  int i;
  for(i=0; i<a->size; i++) {
    res->values[i] = a->values[i] + b->values[i];
  }
}

/* calcule a.b.
 * a et b sont des tableaux de n doubles
 */
double mulv(struct vecteur *a, struct vecteur *b) {
  assert(a->size == b->size);

  int i;
  double res = 0;

  printf("Calcul de mulv(taille des vecteurs: %d)\n", a->size);

  for(i=0; i<a->size; i++) {
    res+= a->values[i] * b->values[i];
  }
  return res;
}

struct vecteur* new_vecteur(int size) {
  struct vecteur * res = malloc(sizeof(struct vecteur));
  assert(res);

  res->size = size;
  res->values = calloc(size, sizeof(double));
  assert(res->values);

  return res;
}

/* desalloue un vecteur */
void free_vecteur(struct vecteur *v) {
  free(v->values);
  free(v);
}

void print_v(struct vecteur *a) {
  int i;
  printf("[");
  for(i=0; i<a->size; i++) {
    printf(" %lf ", a->values[i]);
    if(i+1< a->size)
      printf(",");
  }
  printf("]\n");
}

/* renvoie 1 si a == b */
int vecteur_egal(struct vecteur*a, struct vecteur*b) {
  if(a->size != b->size)
    return 0;

  int i;
  for(i=0; i<a->size; i++)
    if(a->values[i] != b->values[i])
      return 0;

  return 1;
}
