#ifndef FONCTIONS_H
#define FONCTIONS_H

/* vecteur contenant size elements de type double */
struct vecteur {
  int size;
  double* values;
};

enum fonctions {
  SOMME,
  MUL,
  SOMMEV,
  MULV,
  NONE
};

/********************************************
        fonctions de calcul scalaire
 ********************************************/

/* calcule a + b */
double somme(double a, double b);

/* calcule a*b */
double mul(double a, double b);

/* affiche un double */
void print(double a);


/********************************************
        fonctions de calcul vectoriel
 ********************************************/

/* cree un vecteur de taille size */
struct vecteur*  new_vecteur(int size);

/* desalloue un vecteur */
void free_vecteur(struct vecteur *v);

/* affiche un vecteur */
void print_v(struct vecteur *a);


/* res = a + b
 * a, b et res sont des vecteurs de meme taille
 */
void sommev(struct vecteur *a, struct vecteur *b, struct vecteur *res);

/* calcule a.b
 * a et b sont des vecteurs de meme taille
 */
double mulv(struct vecteur *a, struct vecteur *b);

/* renvoie 1 si a == b */
int vecteur_egal(struct vecteur*a, struct vecteur*b);

#endif	/* FONCTIONS_H */
