#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <assert.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <errno.h>
#include <fcntl.h>

#include "fonctions.h"
#include "entrees_sorties.h"

#define TAILLE_V 10
#define NOMTUBESERVEUR "./serveur-rpc"

int fdR;

void traiterRequete(enum fonctions fnum, char*nomtube) {

  /* Réponse sur le tube nommé du client */
  int fdW = open(nomtube, O_WRONLY);
  if (fdW == -1) {
    perror("open(nomtube)");
    exit(EXIT_FAILURE);
  }

  switch(fnum) {

  case SOMME:
    {
      printf("Traitement d'une requete SOMME\n");
      double a = read_double(fdR);
      double b = read_double(fdR);
      double res = somme(a, b);

      write_double(fdW, res);
    }
    break;

  case MUL:
    {
      printf("Traitement d'une requete MUL\n");
      double a = read_double(fdR);
      double b = read_double(fdR);
      double res = mul(a, b);
      write_double(fdW, res);
    }
    break;

  case SOMMEV:
    {
      printf("Traitement d'une requete SOMMEV\n");
      struct vecteur *a = read_vecteur(fdR);
      struct vecteur *b = read_vecteur(fdR);
      struct vecteur *res = new_vecteur(a->size);

      sommev(a, b, res);
      write_vecteur_allocated(fdW, res);

      free_vecteur(a);
      free_vecteur(b);
      free_vecteur(res);
    }
    break;

  case MULV:
    {
      printf("Traitement d'une requete MULV\n");
      struct vecteur *a = read_vecteur(fdR);
      struct vecteur *b = read_vecteur(fdR);
      double res = mulv(a, b);
      write_double(fdW, res);
      free_vecteur(a);
      free_vecteur(b);
    }
    break;

  default:
    printf("Traitement d'une requete inconnue (%d)\n", fnum);
    break;
  }

  /* fermeture du tube une fois la requete traitee */
  close(fdW);
}

int main(int argc, char**argv) {
  int nbRead;

  /* Création du tube nommé pour les communications client -> serveur */

  /* A COMPLETER */

  /* Ouverture de ce tube nommé */

  /* A COMPLETER */


  /* Attente de requêtes */
  do{
    printf("En attente...\n");
    enum fonctions fnum;
    nbRead = read(fdR, &fnum, sizeof(enum fonctions));

    if (nbRead != sizeof(enum fonctions)) {
      perror("read sur tube nomme NOK");
      return EXIT_FAILURE;
    }

    char nomtube[80];
    int len;
    read_str(fdR, nomtube, &len);

    /* On traite la requête */
    traiterRequete(fnum, nomtube);

  }while(1);

  return 0;
}
